# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
rust-version = "1.85"
name = "ecmd"
version = "0.3.0"
authors = ["Joshua Smotritsky"]
build = false
include = [
    "src/**/*",
    "Cargo.toml",
    "LICENSE",
    "README.md",
]
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Type-driven command-line argument parsing"
readme = "README.md"
keywords = [
    "cli",
    "argument",
    "parser",
    "posix",
    "flags",
]
categories = ["command-line-interface"]
license = "MIT"
repository = "https://github.com/eliosai/ecmd"

[features]
default = ["derive"]
derive = ["ecmd-derive"]

[lib]
name = "ecmd"
path = "src/lib.rs"

[dependencies.ecmd-derive]
version = "0.3"
optional = true

[dev-dependencies.pretty_assertions]
version = "1"

[lints.clippy]
absolute_paths = "allow"
allow_attributes = "warn"
allow_attributes_without_reason = "warn"
arithmetic_side_effects = "warn"
as_conversions = "warn"
assertions_on_result_states = "warn"
await_holding_lock = "warn"
await_holding_refcell_ref = "warn"
blanket_clippy_restriction_lints = "allow"
cast_possible_truncation = "warn"
cast_possible_wrap = "warn"
cast_precision_loss = "warn"
cast_sign_loss = "warn"
clone_on_ref_ptr = "warn"
cognitive_complexity = "warn"
dbg_macro = "warn"
debug_assert_with_mut_call = "warn"
default_numeric_fallback = "warn"
enum_glob_use = "warn"
error_impl_error = "allow"
excessive_nesting = "warn"
exhaustive_enums = "warn"
exhaustive_structs = "warn"
expect_used = "warn"
expl_impl_clone_on_copy = "warn"
float_cmp = "warn"
float_cmp_const = "warn"
format_push_string = "warn"
get_unwrap = "warn"
impl_trait_in_params = "allow"
indexing_slicing = "warn"
infallible_try_from = "warn"
integer_division = "warn"
integer_division_remainder_used = "warn"
invalid_upcast_comparisons = "warn"
items_after_statements = "warn"
iter_not_returning_iterator = "warn"
iter_over_hash_type = "warn"
large_futures = "warn"
let_underscore_future = "warn"
let_underscore_must_use = "warn"
lossy_float_literal = "warn"
map_err_ignore = "warn"
mem_forget = "warn"
min_ident_chars = "allow"
missing_const_for_fn = "warn"
missing_errors_doc = "warn"
missing_panics_doc = "warn"
missing_safety_doc = "warn"
mod_module_files = "warn"
module_name_repetitions = "warn"
multiple_unsafe_ops_per_block = "warn"
must_use_candidate = "warn"
panic = "warn"
panic_in_result_fn = "warn"
partial_pub_fields = "warn"
pattern_type_mismatch = "allow"
print_stderr = "warn"
print_stdout = "warn"
pub_with_shorthand = "allow"
question_mark_used = "allow"
rc_buffer = "warn"
rc_mutex = "warn"
redundant_pub_crate = "warn"
ref_patterns = "allow"
semicolon_if_nothing_returned = "warn"
semicolon_inside_block = "warn"
shadow_reuse = "allow"
shadow_same = "allow"
shadow_unrelated = "allow"
single_call_fn = "allow"
single_char_lifetime_names = "allow"
std_instead_of_alloc = "allow"
std_instead_of_core = "allow"
str_to_string = "warn"
string_add = "warn"
string_add_assign = "warn"
string_slice = "warn"
todo = "warn"
too_many_arguments = "warn"
too_many_lines = "warn"
unchecked_time_subtraction = "warn"
undocumented_unsafe_blocks = "warn"
unimplemented = "warn"
unnecessary_safety_comment = "warn"
unnecessary_safety_doc = "warn"
unreachable = "warn"
unseparated_literal_suffix = "warn"
unused_result_ok = "warn"
unwrap_in_result = "warn"
unwrap_used = "warn"
use_debug = "warn"
verbose_file_reads = "warn"
wildcard_dependencies = "warn"
wildcard_imports = "warn"

[lints.clippy.nursery]
level = "warn"
priority = -1

[lints.clippy.pedantic]
level = "warn"
priority = -1

[lints.rust]
missing_docs = "warn"
unsafe_code = "warn"

[lints.rust.rust_2024_compatibility]
level = "warn"
priority = -1
